## Changes in 1.6.0

- Implement new category tree organization functionality for connections
- Rework connection chooser in popup window and in file browser
- Rework user interface
- Add support for sharing your storage via a remote git repository
- Add support for a transparent window mode
- Upgrade to GraalVM 21
- Improve command process synchronization to try to fix rare race conditions and deadlocks
- Dynamically check whether kubectl requires elevation to fix permission issues, for example when using rancher k3s
- Add attach and logs context menu actions for docker containers
- Add support for VSCode Insiders
- Add support for ElementaryOS terminal
- Add support ash shells
- Improve error handler to also show a graphical window before the application window is opened
- Make shell environment init script apply changes to the shell session by sourcing it
- Rework powershell execution policy usage to not override system default
- Improve resilience of storage loading and saving in case of IO errors
- Improve browser tab naming and sizing
- Automatically apply local clipboard changes to browser
- Preserve clipboard contents after exit
- Add support to open ssh: URLs
- Add functionality to open ssh connections in Termius
- Add functionality to open ssh connections in default SFTP client
- Add functionality to create desktop shortcuts and URLs for certain actions within XPipe
- Rework installer packages
- Properly query desktop directory on Windows and Linux in case it was at non-standard locations
- Check whether target exists when renaming or moving in file browser
- Fix ssh config entry being added even if it was empty
- Fix passcode PAM authentication caching responses
- Fix Powershell remote sessions not working correctly
- Many other small miscellaneous fixes and improvements

## Experimental releases

There are already many other feature branches in the pipeline and will be released soon.
In fact as of now, you can already try out the next major 1.7 release in the [XPipe PTB](https://github.com/xpipe-io/xpipe-ptb) (Public Test Build).
The regular releases and new PTB releases are designed to not interfere with each other and can therefore be installed and used side by side.