## New professional features

- Add ability to open files and directories in VSCode SSH remote environment in file browser
- Added support for fully offline licenses. You can obtain them via email request
  in case you're running it on a system without internet connectivity or restricted proxy settings

## Changes

- Make current default shell also show up in shell environments to prevent confusion about missing bash environment
- Improve error messages when an additional password was requested by the connection
  when none was provided instead of just showing permission denied
- Make SSH connection starting from a WSL environment use the native Windows key helper for FIDO2 keys
- Rework insights button for connection creation across the board

## Additions

- Add warning message if git vault URL was an HTTP URL and you are trying to use an SSH identity
- Add ability to clone existing connections to make the process of adding similar connections easier
- Add ability to debug local background shell in developer options
- Add notice when a professional feature is available in preview mode
- Add some more OS logos
- Add check to verify whether font loading with fontconfig works on Linux on startup
- Add more extensive note on first startup for potential issues when Malwarebytes, McAfee, or Bitdefender are installed

## Fixes

- Fix application not starting on Asahi Linux due to executable page size issue
- Fix file existence check for SSH key files reporting wrong results on Windows in directory links/junctions
- Fix k8s integration not working when user did not have permission to list nodes
- Fix rare error when switching to tray operation mode on Linux
- Fix connection state not being preserved when being added the first time
- Fix application failing to start up if OS reported invalid screen size bounds
- Fix VMware VM not being able to be parsed if configuration file did not specify an encoding or name
- Fix startup failing when installation was located on a ramdisk
- Fix some miscellaneous cache data being stored in the user home directory
- Fix error handling when jump host chain formed a loop
- Fix PowerShell remote sessions being blocked by execution policy
- Fix race condition when locking user data directory
- Fix some CLI commands not starting daemon correctly if it is not already running
- Fix text field when showing askpass window not being focused automatically
- Fix combobox selections not working well with keyboard-only workflows
- Fix many possible small NullPointerExceptions
