## Changes

- You can now add SSH connections from arbitrary OpenSSH config files under `Add remote host` -> `SSH Config`
- The SSH config importer now supports include statements. Included files are automatically resolved and joined
- Add experimental ability to automatically fix SSH key file permissions on Windows if OpenSSH complains
- Rework file browser connection history overview to always update when you close a tab
- The Linux installers now correctly report their dependencies. This was not really a problem on any
  normal desktop system, but should make it easier to run on embedded systems or in WSL2g
- Improve performance mode speedup by removing more styling. You can enable the mode under Settings -> Appearance
- Change layout of connection names and status to better handle very long connection names across all window sizes
- Make any connection quickly renameable in the edit window without verifying whether we can actually connect
- Allow for creation of multiple connections with the same name
- Add a self test functionality on startup to handle cases where the local shell could not be initialized correctly
- Implement fallback to bundled fonts on Linux systems that do not have fontconfig
- There is now a repository for nixos releases at https://github.com/xpipe-io/nixpkg
- Improve documentation for custom terminal command setting

## Fixes

- Fix some zsh shells not properly setting up the PATH
- Fix git vault repository throwing initialization errors when shared with multiple Windows user permissions
- Fix displayed connection summary not updating on edit
- Fix copying and pasting a file into the same directory returning an error
- Fix connections being accidentally listed under scripts category
  if they were added while scripts category was selected
- Fix default terminal detection sometimes selecting iTerm even though it was not installed
- Fix shell environments for BSD bourne shell failing with invalid -l switch
- Fix connections to pfSense systems not working
