## Changes

- Add support to create customized SSH connections using arbitrary options.
  This can be done using the SSH config format but without having to create an actual file.
- Unify all SSH connection types to support the same functionality.
  I.e. they all now support host key and identity file fixes plus can be used with SSH tunnels.
- Make it possible to specify any identity to be used for SSH config connections
- Properly detect when an active connection has unexpectedly reset during a file browser session.
  It will now be automatically restarted when any action is performed and fails.
- Rework connection creation menu layout to give a better overview
- Make the connection timeout value in the settings properly apply to ssh connections as well.
  This should help with SSH connections that take a long time to connect.
- Include pre-rasterized images for various sizes to reduce the render load at runtime
- Implement various performance improvements
- Rework some UI elements to better work with keyboard navigation and screen readers
- Add unsupported shell notice when restricted bash is detected
- The daemon now properly reports any startup failure causes when started from the CLI via `xpipe open`
- Regularly clean logs directory to free up older log files
- Improve file browser handling in smaller window sizes
- Add support for WezTerm and Windows Terminal Preview

## Fixes

- Fix application windows on Linux not initializing with the correct size
- Fix connections to pfSense systems not working (This time properly)
- Fix NullPointerException when a Linux system did not provide any release name
- Fix startup errors when operating system reported invalid window sizes
- Fix various Exceptions caused by race conditions
