## Changes in 1.7.4

### VMware support for desktop hypervisors

This update introduces an experimental implementation to support VMware virtual machines in VMware Player, Workstation, and Fusion installations.
The support includes actions like listing, starting, stopping, and pausing VMs plus opening a shell session or file browser session via SSH.

Note that the initial connection to a VM, which runs some setup, can take a long time.
It seems like the VMware CLI it is very slow in that regard, maybe I can find some improvements.

If everything works out well with this first attempt at VM support, it can be expanded to other hypervisors.

### Git storage for everyone

Up until now, the git storage functionality has only been available with a professional license.
However, due to the complex nature of git repositories, this feature had some inevitable rough edges
and did not live up to the robustness of a professional product.

As a result, I am moving this feature into the community edition.

### UI rework

Some parts of the UI have been reworked to achieve a more consistent appearance.
Furthermore, it has also been improved in regard to accessibility and its interaction with screen readers. 

### Other changes

- The left sidebars in the connection overview and browser can now be persistently resized
- Implement various performance improvements
- When dragging files straight out of the browser, they now can also resolve to text output.
  You can therefore now drag files into a terminal to quickly paste their file names for example.
- Rework connection creation to automatically preselect most commonly used type
- Fix browser exit race conditions
- Fix application not starting up when settings file was corrupted
- Fix connection getting stuck when shell did not support stderr. It will now just stop after a few seconds
- Fix application not starting up on Windows systems older than Windows 10
- Fix negative process exit codes being interpreted as internal errors and not shown

## Previous changes in 1.7

- [1.7.3](https://github.com/xpipe-io/xpipe/releases/tag/1.7.3)
- [1.7.2](https://github.com/xpipe-io/xpipe/releases/tag/1.7.2)
- [1.7.1](https://github.com/xpipe-io/xpipe/releases/tag/1.7.1)
