### Git storage rework

The git storage functionality has been in a bad state, hopefully this update will change that.
First of all, several bugs and inconsistencies have been fixed.

Furthermore, the authentication options have been greatly expanded.
You can now supply both HTTP and SSH git URLs. If any input is required like a username/password/passphrase, XPipe will show a prompt.
If you chose to use an SSH git URL, you can also set key-based authentication options just as for other ssh connections.

Lastly, there is now a general data directory as well in which you can put any additional files like SSH keys that you want to include in the repository. You can then refer to them just as normal within XPipe but their file paths are automatically adapted on any system you clone the repository to. You can open this data directory from the settings menu.

It is recommended to start with a remote git repository from scratch though to properly fix previous issues.

### Other changes

- Fix new daemon instances getting stuck when trying to communicate with an already running daemon that does not respond
- Fix daemon not properly exiting when stuck on shutdown
- Fix elevated commands getting stuck if no sudo password was available
- Fix some commands getting stuck under rare conditions on Linux and macOS
- Fix some windows being shown outside of screen bounds when display scaling values were set very high
- Fix macOS .pkg installers requiring Rosetta to be installed on ARM even though it wasn't needed
- Fix powerlevel10k breaking terminal integrations on macOS
- Fix screen clear on terminal launch sometimes breaking terminal formatting
- Fix process exit codes outside of signed 32-bit int causing errors
- Fix local shell process not restarting if it somehow died
- Fix errors not showing when GUI could not be initialized
- Fix some NullPointerExceptions
- Fix file browser execute action not launching scripts
- Fix some license related errors
- Fix Windows os detection on remote servers if cmd was not available
- Many other small miscellaneous fixes and improvements

Please make sure to report any issue you can find. This helps the development a lot.
