## Windows updater issues

The last few versions of XPipe from 1.7.16 to 8.0.1 all had a self-updater on Windows that was not working properly. This was caused by a newly introduced JDK bug. This is now fixed from 8.1 onwards.

To upgrade to 8.1+, you have to do it manually by downloading and installing it from https://github.com/xpipe-io/xpipe/releases. There shouldn't be any more problems with 8.1+ after that.

## Git Vault Versioning

When upgrading XPipe versions across many systems, one problem could have been the git vault format being updated on one system and being pulled on another a system that is running an older version. This could have led to data corruption. From now on, there will be a warning shown when the versions do not match up. From there you can choose to temporarily disable the git vault during a session until you upgrade to the matching version on that system as well.

This check however only works from 8.1 onwards. Older git vaults do not contain version information. So if this happens to you while updating from a previous version, e.g. 1.7.16, you should be able to reset the git repository to a previous ref.

## Filtering for hosts

You can now search for IPs and hostnames in addition to the connection names to filter your connection list. The connection display when a filter is active has also been improved.

## File browser transfer fixes

There was a regression in transfer speed in 8.0 causing transfers of large files being very slow. This is now fixed.

## Open directories in WSL

There is now a new action available in the file browser for directories on Windows systems that allows you to open that directory in a WSL session. This makes it easier to quickly use Linux tools in a certain directory you're currently in when on Windows.

## Other changes

- Fix fallback shell action throwing some errors initially
- Properly set TERM variable for powershell environments
- Improve styling in some areas
- Better validate invalid settings values on startup
- Fix concurrency issues when querying multiple secrets at the same time
- Fix red validation markers appearing in front of other UI elements
- Fix msys2, cygwin, and gitforwindows shell environments being shown for the wrong parent connection when located on remote systems
- Fix transferred files with BOM sometimes getting corrupted on Windows systems
- Fix SSH askpass throwing errors on Windows systems where username contained special characters due to an OpenSSH bug
- Fix some null pointers